/**
 * Created by Tony on 2017/11/21.
 */

let test = require('tape');
const JpcEx = require("../../../modules/reports/rpt_component/jpc_ex");
const JV = require("../../../modules/reports/rpt_component/jpc_value_define");
let config = require("../../../config/config.js");
config.setupDb(process.env.NODE_ENV);
let mongoose = require("mongoose");
let fileUtils = require("../../../modules/common/fileUtils");
let path = require('path');
let dbm = require("../../../config/db/db_manager");
let rpt_cfg = require('./rpt_cfg');
dbm.connect(process.env.NODE_ENV);

//统一引用models
fileUtils.getGlobbedFiles('../../../modules/all_models/*.js').forEach(function(modelPath) {
    require(path.resolve(modelPath));
});

let cfgCacheUtil = require("../../../config/cacheCfg");
cfgCacheUtil.setupDftCache();

let fsUtil = require("../../../public/fsUtil");

let demoPrjId = - 1;
// let demoRptId = 223, pagesize = "A4";
let demoRptId = 261, pagesize = "A4";

// demoPrjId = 1220; //QA:
demoPrjId = 2260;
//*
let userId_Leng = "5acac1e885bf55000bd055ba"; //小冷User Id 换成_id了
let userId_Dft = userId_Leng;
/*/
 let userId_Dft = "595328da1934dc327cad08eb";
//*/

let rptTplFacade = require("../../../modules/reports/facade/rpt_template_facade");
let rptTplDataFacade = require("../../../modules/reports/facade/rpt_tpl_data_facade");

const rptDataExtractor = require("../../../modules/reports/util/rpt_construct_data_util");

let fs = require('fs');
//设置Date Format函数
fs.readFile(__dirname.slice(0, __dirname.length - 18) + '/public/web/date_util.js', 'utf8', 'r', function (err, data) {
    eval(data);
});

//*
test('测试 - 打开模板: 封-3 ', function (t) {
    rptTplFacade.getRptTemplate(demoRptId).then(function(rptTpl) {
        let rptDataUtil = new rptDataExtractor();
        rptDataUtil.initialize(rptTpl._doc);
        let filter = rptDataUtil.getDataRequestFilter();
        // console.log(filter);
        //正常应该根据报表模板定义的数据类型来请求数据
        rptTplDataFacade.prepareProjectData(userId_Dft, demoPrjId, filter, function (err, msg, rawDataObj) {
            if (!err) {
                try {
                    // fsUtil.writeObjToFile(rawDataObj, "D:/GitHome/ConstructionCost/tmp/rptTplRawDataObject_建筑封-3表.jsp");
                    let tplData = rptDataUtil.assembleData(rawDataObj);
                    // fsUtil.writeObjToFile(tplData, "D:/GitHome/ConstructionCost/tmp/rptTplAssembledData_建筑封-3表.jsp");
                    //build the report
                    let printCom = JpcEx.createNew();
                    rptTpl[JV.NODE_MAIN_INFO][JV.NODE_PAGE_INFO][JV.PROP_PAGE_SIZE] = pagesize;
                    let defProperties = rpt_cfg;
                    let dftOption = JV.PAGING_OPTION_NORMAL;
                    printCom.initialize(rptTpl);
                    printCom.analyzeData(rptTpl, tplData, defProperties, dftOption);
                    let maxPages = printCom.totalPages;
                    let pageRst = printCom.outputAsSimpleJSONPageArray(rptTpl, tplData, 1, maxPages, defProperties);
                    if (pageRst) {
                        fsUtil.writeObjToFile(pageRst, "D:/GitHome/ConstructionCost/tmp/testBuiltPageResult_建筑封-3.jsp");
                    } else {
                        console.log("oh! no pages were created!");
                    }
                } catch (ex) {
                    console.log(ex);
                    t.pass('pass with exception!');
                    t.end();
                }

                t.pass('pass succeeded!');
                t.end();
            } else {
                console.log(msg);
                t.pass('pass with error!');
                t.end();
            }
        })
    });
});
//*/

test('close the connection', function (t) {
    setTimeout(function () {
        mongoose.disconnect();
        t.pass('closing db connection');
        t.end();
    }, 1000);
    // mongoose.disconnect();
    // t.pass('closing db connection');
    // t.end();
});